#!/bin/sh
### BEGIN INIT INFO
# Provides:          swd
# Required-Start:    $network $syslog
# Required-Stop:     $network $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# X-Interactive:     true
# Short-Description: Start/stop swd daemon
### END INIT INFO

DAEMON=/usr/sbin/swd
NAME=swd
PIDFILE=/var/run/swd.pid
DESC="SW daemon"
ARGS=""

test -f $DAEMON || exit 0

set -e

out () {
    if [ -z "$QUIET" ]; then
	echo $*
    fi
}

case "$1" in
    start)
        out -n "starting $DESC: $NAME... "
	start-stop-daemon -S -n $NAME -a $DAEMON --pidfile $PIDFILE -- $ARGS >/dev/null 2>&1
	ps | grep -v grep | grep -q swd-check.sh || (/usr/sbin/swd-check.sh &)
	out "done."
	;;
    stop)
        out -n "stopping $DESC: $NAME... "
	PID=`start-stop-daemon -K -n $NAME --pidfile $PIDFILE|sed 's/^.*(pid \([0-9]\+\)).*$/\1/'`
	PID=${PID##*none*}
	if [ -n "$PID" ]; then
	    # waiting until really stopped
	    i=0
	    while kill -0 "${PID:-}" 2> /dev/null;  do
		if [ $i = '60' ]; then
		    out " still alive, killing PID ${PID:-}... "
		    kill -9 "${PID:-}"
		    #start-stop-daemon -K -n $NAME --pidfile $PIDFILE --signal KILL
		    break;
		else
		    if [ $i = '0' ]; then
			out -n " waiting "
		    else
			out -n "."
		    fi
		    i=$(($i+1))
		    sleep 1
		fi
	    done
	fi
	out "done."
	;;
    restart)
	if [ -z "$WEB_UPGRADE" ]; then
	    out "restarting $DESC: $NAME... "
	    touch /tmp/restarting-swd
	    $0 stop
	    $0 start
	    rm -f /tmp/restarting-swd
	    out "done."
	else
	    echo '<script language="javascript" type="text/javascript">'
	    echo '<!--'
	    echo 'try {'
	    echo 'window.top.window.needRestart();'
	    echo '} catch(e) {}'
	    echo '-->'
	    echo '</script>'
	fi

	if [ -f /etc/init.d/busybox-httpd ]; then
	    start-stop-daemon -S -b -x /usr/sbin/remove-external-server.sh
	fi
	;;
    status)
        out -n "Getting status of $DESC: $NAME"
        if start-stop-daemon -q -K --test -n $NAME --pidfile $PIDFILE
	then out " - is running."
	else out " - is not running."
	fi
    	;;
    *)
	out "Usage: $0 {start|stop|restart|status}"
	exit 1
	;;
esac

exit 0
