<?php
header("Content-Type: text/plain");
date_default_timezone_set("UTC");

function oid2list($oid, $shift = 0) {
    $splitted = explode('.', $oid);
    array_pop($splitted);
    for($i = $shift; $i >= 0; --$i)
	array_shift($splitted);
    return implode(" ", $splitted);
}

function describe($parent, $mib, $shift = 0) { 
    foreach($mib as $item) {
	$entry = $item->name."Entry";
	if($item->type == "TABLE") {
	    echo "$item->name OBJECT-TYPE\n";
	    echo "    SYNTAX    SEQUENCE OF $entry\n";
	    echo "    ACCESS    not-accessible\n";
	    echo "    STATUS    current\n";
	    echo "    DESCRIPTION \"$item->desc\"\n";
	    echo "    ::= { $parent ".oid2list($item->oid, $shift)." }\n\n";
	    echo "$entry OBJECT-TYPE\n";
	    echo "    SYNTAX  $entry\n";
	    echo "    ACCESS    not-accessible\n";
	    echo "    STATUS    current\n";
	    echo "    DESCRIPTION \"$item->name table entry\"\n";
#	    echo "    INDEX     { ??? }\n";		TODO Что тут писать?
	    echo "    ::= { $item->name 1 }\n\n";
	    echo "$entry ::=\n";
	    echo "    SEQUENCE {\n";
	    $arr = array();
	    foreach($item->line as $v) {
		$type = $v->type;
		if($type == "TABLE")
		    $type = $v->name;		# TODO Что тут писать, если элементом строки таблицы является другая таблица?
		array_push($arr, "        $v->name\n            $v->type");
	    }
	    echo implode(",\n", $arr)."\n";
	    echo "    }\n\n";
	    describe($entry, $item->line, $shift + 2);
	    continue;
	}
	$type = $item->type;
	$access = "none";
	switch($item->type) {
	case "INT64":
	    $type = "INTEGER";
	    break;
	case "STRING":
	    $type = "OCTET STRING";
	    break;
	}
	switch($item->access) {
	case "RO":
	    $access = "read-only";
	    break;
	case "RW":
	    $access = "read-write";
	    break;
	case "WO":
	    $access = "write-only";
	    break;
	}
	echo "$item->name OBJECT-TYPE\n";
	echo "    SYNTAX      $type\n";
	echo "    MAX-ACCESS  $access\n";
	echo "    STATUS      current\n";
	echo "    DESCRIPTION \"$item->desc\"\n";
	echo "    ::= { $parent ".oid2list($item->oid, $shift)." }\n\n";
    }
}

    $socket = socket_create(AF_UNIX, SOCK_STREAM, 0);
    if (!$socket) {
	echo '{"error":"Unable to create UNIX socket: ' . socket_strerror(socket_last_error()) . '"}';
	exit;
    }
    if(!socket_connect($socket, '/var/run/swd.sock')) {
	echo '{"error": "Unable to connect: ' . socket_strerror(socket_last_error()) . '"}';
	exit;
    }
    $slot = $_REQUEST['slot'];
    if(!socket_write($socket, stripslashes('{"cmd":"getMIB","slot":'.$slot.'}'))) {
	echo '{"error":"Unable to write: ' . socket_strerror(socket_last_error()) . '"}';
	exit;
    }
    $res = socket_read($socket, 1000000);
    $rrr = json_decode($res);
    if(array_key_exists('error', $rrr)) {
	echo "Error: ".$rrr->error."\n";
	exit;
    }
    $name = $rrr->name;
    $mib = $rrr->mib;
    echo "--\n";
    echo "-- Copyright (c) ".date("Y")." ADC\n";
    echo "--      All rights reserved.\n";
    echo "--\n";
    echo "-- Author: Alex Mogilnikov <alx@kolez.com>\n";
    echo "--\n";
    echo "-- Redistribution and use in source and binary forms, with or without\n";
    echo "-- modification, are permitted provided that the following conditions\n";
    echo "-- are met:\n";
    echo "-- 1. Redistributions of source code must retain the above copyright\n";
    echo "--    notice, this list of conditions and the following disclaimer.\n";
    echo "-- 2. Redistributions in binary form must reproduce the above copyright\n";
    echo "--    notice, this list of conditions and the following disclaimer in the\n";
    echo "--    documentation and/or other materials provided with the distribution.\n";
    echo "--\n";
    echo "-- THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND\n";
    echo "-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\n";
    echo "-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\n";
    echo "-- ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE\n";
    echo "-- FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\n";
    echo "-- DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\n";
    echo "-- OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\n";
    echo "-- HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\n";
    echo "-- LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\n";
    echo "-- OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\n";
    echo "-- SUCH DAMAGE.\n";
    echo "--\n";
    echo "$name-MIB DEFINITIONS ::= BEGIN\n\n";
    echo "IMPORTS\n";
    echo "    MODULE-IDENTITY, OBJECT-TYPE\n";
    echo "        FROM SNMPv2-SMI\n";
    echo "    BoardsEntry, INT8, INT16, INT32\n";
    echo "        FROM M3U160;\n\n";

    echo "$name MODULE-IDENTITY\n";
    echo "    LAST-UPDATED \"".date("Ymd0000Z")."\"\n";
    echo "    ORGANIZATION \"ADC\"\n";
    echo "    CONTACT-INFO\n";
    echo "               \"EMail:        alx@kolez.com\n";
    echo "                www:          http://www.adc-line.ru/\n";
    echo "                Postal:       ADC, bla-bla-bla,\n";		# TODO
    echo "                              Perm, 614000, Russia\n";	# TODO
    echo "                Phone:        +7 342 2345678\n";		# TODO
    echo "                Fax:          +7 342 2345678\"\n";		# TODO
    echo "    DESCRIPTION\n";
    echo "            \"The MIB module for ".$name." board\n";
    echo "             Copyright (C) ADC (".date("Y").").\"\n";
    echo "    ::= { BoardsEntry $slot }\n\n";

    describe($name, $mib);

    echo "END\n";
?>
